Index: src/org/jboss/ide/eclipse/freemarker/Plugin.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/Plugin.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/Plugin.java	(working copy)
@@ -21,6 +21,7 @@
  */
 package org.jboss.ide.eclipse.freemarker;
 
+import java.io.IOException;
 import java.io.PrintWriter;
 import java.io.StringWriter;
 import java.net.MalformedURLException;
@@ -40,9 +41,14 @@
 import org.eclipse.jface.dialogs.MessageDialog;
 import org.eclipse.jface.resource.ImageDescriptor;
 import org.eclipse.jface.resource.ImageRegistry;
+import org.eclipse.jface.text.templates.ContextTypeRegistry;
+import org.eclipse.jface.text.templates.persistence.TemplateStore;
 import org.eclipse.swt.graphics.Image;
 import org.eclipse.swt.widgets.Display;
+import org.eclipse.ui.editors.text.templates.ContributionContextTypeRegistry;
+import org.eclipse.ui.editors.text.templates.ContributionTemplateStore;
 import org.eclipse.ui.plugin.AbstractUIPlugin;
+import org.jboss.ide.eclipse.freemarker.template.FreemarkerTemplateContextType;
 import org.osgi.framework.Bundle;
 
 /**
@@ -167,4 +173,34 @@
 		}
 		return null;
 	}
+	
+	private TemplateStore fStore;
+	
+	private ContributionContextTypeRegistry fRegistry;
+	
+	public ContextTypeRegistry getContextTypeRegistry(){
+        if(fRegistry == null) {
+            fRegistry = new ContributionContextTypeRegistry();
+            fRegistry.addContextType(FreemarkerTemplateContextType.FREEMARKER_CONTEXT_TYPE);
+        }
+        return fRegistry;
+    }
+	
+	 public TemplateStore getTemplateStore()
+	     {
+	         if(fStore == null)
+	         {
+	             fStore = new ContributionTemplateStore(getContextTypeRegistry(), getDefault().getPreferenceStore(), 
+	                     "org.jboss.ide.eclipse.freemarker.templates");
+	             try
+	             {
+	                 fStore.load();
+	             }
+	             catch(IOException e)
+	             {
+	                 log(e);
+	             }
+	         }
+	         return fStore;
+	     }   
 }
\ No newline at end of file
Index: src/org/jboss/ide/eclipse/freemarker/FreemarkerMessages.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/FreemarkerMessages.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/FreemarkerMessages.java	(revision 0)
@@ -0,0 +1,53 @@
+package org.jboss.ide.eclipse.freemarker;
+
+import java.text.MessageFormat;
+import java.util.MissingResourceException;
+import java.util.ResourceBundle;
+
+/**
+ * 
+ * Freemarker Messages (see resources.properties).
+ *  
+ * @version 1.0.4 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class FreemarkerMessages {
+	
+	private static final String BUNDLE_NAME = "org.jboss.ide.eclipse.freemarker.resources";
+
+	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
+			.getBundle(BUNDLE_NAME);
+
+	private FreemarkerMessages() {
+	}
+
+	public static String getString(String key) {
+		try {
+			return RESOURCE_BUNDLE.getString(key);
+		} catch (MissingResourceException e) {
+			return '!' + key + '!';
+		}
+	}
+	
+	public static String getString(String key, String arg0) {
+		String[] args = {arg0};
+		return getString(key, args);
+	}
+	
+	public static String getString(String key, String arg0, String arg1) {
+		String[] args = {arg0, arg1};
+		return getString(key, args);
+	}
+	
+	public static String getString(String key, String[] args) {
+		if (args == null)
+			return getString(key);
+		try {
+			return MessageFormat.format(getString(key), args);
+		}
+		catch(Exception e) {
+			return '!' + key + '!';
+		}
+	}	
+}
Index: src/org/jboss/ide/eclipse/freemarker/outline/OutlineContentProvider.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/outline/OutlineContentProvider.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/outline/OutlineContentProvider.java	(working copy)
@@ -27,7 +27,8 @@
 
 import org.eclipse.jface.viewers.ITreeContentProvider;
 import org.eclipse.jface.viewers.Viewer;
-import org.jboss.ide.eclipse.freemarker.editor.Editor;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.SourceEditor;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.SourceEditor;
 import org.jboss.ide.eclipse.freemarker.model.Item;
 import org.jboss.ide.eclipse.freemarker.model.ItemSet;
 import org.jboss.ide.eclipse.freemarker.model.MacroDirective;
@@ -36,9 +37,9 @@
  * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
  */
 public class OutlineContentProvider implements ITreeContentProvider {
-	private Editor fEditor;
+	private SourceEditor fEditor;
 
-	public OutlineContentProvider(Editor anEditor) {
+	public OutlineContentProvider(SourceEditor anEditor) {
 		fEditor = anEditor;
 	}
 
Index: src/org/jboss/ide/eclipse/freemarker/outline/OutlinePage.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/outline/OutlinePage.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/outline/OutlinePage.java	(working copy)
@@ -49,8 +49,8 @@
 import org.jboss.ide.eclipse.freemarker.Messages;
 import org.jboss.ide.eclipse.freemarker.Plugin;
 import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
-import org.jboss.ide.eclipse.freemarker.configuration.ContextValue;
-import org.jboss.ide.eclipse.freemarker.editor.Editor;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.SourceEditor;
 import org.jboss.ide.eclipse.freemarker.model.Interpolation;
 import org.jboss.ide.eclipse.freemarker.model.Item;
 import org.jboss.ide.eclipse.freemarker.model.ItemSet;
@@ -60,11 +60,11 @@
  * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
  */
 public class OutlinePage extends ContentOutlinePage implements IDoubleClickListener {
-	private Editor fEditor;
+	private SourceEditor fEditor;
 	private Object fInput;
 	private OutlineLabelProvider fLabelProvider;
 
-	public OutlinePage(Editor anEditor) {
+	public OutlinePage(SourceEditor anEditor) {
 		fEditor = anEditor;
 	}
 
@@ -184,11 +184,13 @@
 							ConfigurationManager configuration = ConfigurationManager.getInstance(interpolation.getResource().getProject());
 							IType type = (IType) objects[0];
 							try {
-								configuration.addContextValue(
-										new ContextValue(interpolation.getFirstToken(), 
-												configuration.getClass(type.getFullyQualifiedName()), null), interpolation.getResource());
+							    // TODO : manage other context type (like XML, ...)
+                                int contextType = IContextValue.CLASS; 
+                                IContextValue contextValue = configuration.getInstanceOfContextValue(contextType, interpolation.getFirstToken(), 
+                                        type.getFullyQualifiedName(), null);
+                                configuration.addContextValue(contextValue, interpolation.getResource());
 							}
-							catch (ClassNotFoundException e) {
+							catch (Exception e) {
 								Plugin.log(e);
 							}
 						}
Index: src/org/jboss/ide/eclipse/freemarker/editor/editorpart/PreviewEditor.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/editor/editorpart/PreviewEditor.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/editor/editorpart/PreviewEditor.java	(revision 0)
@@ -0,0 +1,155 @@
+package org.jboss.ide.eclipse.freemarker.editor.editorpart;
+
+import java.io.IOException;
+import java.io.PrintWriter;
+import java.io.Reader;
+import java.io.StringReader;
+import java.io.StringWriter;
+import java.util.HashMap;
+import java.util.Map;
+
+import org.eclipse.core.resources.IFile;
+import org.eclipse.core.resources.IProject;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.jface.text.IDocument;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.custom.StyledText;
+import org.eclipse.swt.layout.FillLayout;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.ui.IEditorInput;
+import org.eclipse.ui.IEditorSite;
+import org.eclipse.ui.IWorkbenchPartSite;
+import org.eclipse.ui.PartInitException;
+import org.eclipse.ui.part.EditorPart;
+import org.jboss.ide.eclipse.freemarker.Plugin;
+import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
+import org.w3c.dom.Document;
+
+import freemarker.ext.dom.NodeModel;
+import freemarker.template.Configuration;
+import freemarker.template.Template;
+import freemarker.template.TemplateException;
+
+/**
+ * 
+ * Preview Editor for the ftl template.  
+ * 
+ * @version 1.0.4 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class PreviewEditor extends EditorPart  {
+
+    private IEditorSite site;
+    private PreviewEditorInput previewEditorInput;
+    private StyledText text;
+    private Configuration freemarkerConfiguration;
+    
+    public PreviewEditor() {
+        this.freemarkerConfiguration = new Configuration();
+    }
+    
+    public void doSave(IProgressMonitor arg0) {  
+    }
+
+    public void doSaveAs() {
+    }
+
+    public void init(IEditorSite site, IEditorInput input) throws PartInitException {
+        this.site = site;
+        previewEditorInput = (PreviewEditorInput)input;
+    }
+
+    public boolean isDirty() {
+        return false;
+    }
+
+    public boolean isSaveAsAllowed() {
+        return false;
+    }
+
+    public void createPartControl(Composite composite) {
+        FillLayout layout = new FillLayout();
+        composite.setLayout(layout);
+        text = new StyledText(composite, SWT.H_SCROLL | SWT.V_SCROLL);
+        text.setEditable(false);
+    }
+
+    public void setFocus() {
+        preview();
+    }
+    
+    public IWorkbenchPartSite getSite() {
+        return site;
+    }
+    
+    private void preview() {
+        text.setText("");
+        IDocument sourceDocument = previewEditorInput.getSourceDocument();
+        IFile contextValuesFile = previewEditorInput.getContextValuesFile();
+        String pageContents = sourceDocument.get();
+        try {
+            IProject project = contextValuesFile.getProject();
+            /* Prepare Freemarker template with Source tab */ 
+            Reader reader = new StringReader(pageContents);
+            Template template = new Template("preview.ftl", reader, this.freemarkerConfiguration);
+            reader.close();     
+            
+            /* Prepare Model */ 
+            Map model = new HashMap();
+            IContextValue[] contextValues = ConfigurationManager.getInstance(
+                    project).getContextValues(contextValuesFile, false);
+            if (contextValues != null) {
+                for (int i = 0; i < contextValues.length; i++) {
+                    IContextValue contextValue = contextValues[i];
+                    String contextName = contextValue.getName();
+                    if (IContextValue.STRING == contextValue.getType()) {
+                        String stringValue = (String)contextValue.getFirstObjectContext().getObject();
+                        model.put(contextName , stringValue);
+                    }
+                    else {
+                        if (IContextValue.XML == contextValue.getType()) {
+                            Document document = (Document)contextValue.getFirstObjectContext().getObject();
+                            NodeModel nodeModel = NodeModel.wrap(document);
+                            model.put(contextName , nodeModel);
+                        }
+                        else {
+                            if (IContextValue.CLASS == contextValue.getType()) {
+                                Class objectClass = (Class)contextValue.getFirstObjectContext().getObject();
+                                try {
+                                    Object objectInstance = objectClass.newInstance();
+                                    model.put(contextName , objectInstance);
+                                }
+                                catch (Exception e) {
+                                    Plugin.log(e);
+                                }
+                            }
+                        }
+                    }
+                    
+                }
+            }
+            
+             /* Merge data model with template */
+            StringWriter out = new StringWriter();
+            template.process(model, out);
+            out.flush();    
+            
+            text.setText(out.toString());
+            
+        } catch (TemplateException e) {
+            StringWriter out = new StringWriter();
+            PrintWriter print = new PrintWriter(out);
+            e.printStackTrace(print);
+            out.flush();    
+            text.setText(out.toString());
+            Plugin.log(e);
+        }
+        catch (IOException e) {
+            Plugin.log(e);
+        }   
+    }
+
+
+}
Index: src/org/jboss/ide/eclipse/freemarker/editor/editorpart/PreviewEditorInput.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/editor/editorpart/PreviewEditorInput.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/editor/editorpart/PreviewEditorInput.java	(revision 0)
@@ -0,0 +1,56 @@
+package org.jboss.ide.eclipse.freemarker.editor.editorpart;
+
+import org.eclipse.core.resources.IFile;
+import org.eclipse.jface.resource.ImageDescriptor;
+import org.eclipse.jface.text.IDocument;
+import org.eclipse.ui.IEditorInput;
+import org.eclipse.ui.IPersistableElement;
+
+/**
+ * 
+ * Description : 
+ * @version 1.0.0 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class PreviewEditorInput implements IEditorInput {
+
+    private IDocument sourceDocument;
+    private IFile contextValuesFile;
+    
+    public PreviewEditorInput(IFile contextValuesFile, IDocument sourceDocument) {
+        this.sourceDocument = sourceDocument;
+        this.contextValuesFile = contextValuesFile;
+    }
+    
+    public Object getAdapter(Class arg0) {
+        return null;
+    }
+
+    public boolean exists() {
+        return false;
+    }
+
+    public ImageDescriptor getImageDescriptor() {
+        return null;
+    }
+
+    public String getName() {
+        return "PrevEd";
+    }
+
+    public IPersistableElement getPersistable() {
+        return null;
+    }
+
+    public String getToolTipText() {
+        return null;
+    }
+    public IDocument getSourceDocument() {
+        return sourceDocument;
+    }
+    public IFile getContextValuesFile() {
+        return contextValuesFile;
+    }
+
+}
Index: src/org/jboss/ide/eclipse/freemarker/editor/editorpart/SourceEditor.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/editor/editorpart/SourceEditor.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/editor/editorpart/SourceEditor.java	(revision 0)
@@ -0,0 +1,502 @@
+/*
+ * JBoss, a division of Red Hat
+ * Copyright 2006, Red Hat Middleware, LLC, and individual contributors as indicated
+ * by the @authors tag. See the copyright.txt in the distribution for a
+ * full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.ide.eclipse.freemarker.editor.editorpart;
+
+import java.io.Reader;
+import java.io.StringReader;
+import java.util.HashMap;
+import java.util.Map;
+
+import org.eclipse.core.resources.IFile;
+import org.eclipse.core.resources.IMarker;
+import org.eclipse.core.resources.IProject;
+import org.eclipse.core.resources.IResource;
+import org.eclipse.jdt.internal.ui.javaeditor.JarEntryEditorInput;
+import org.eclipse.jdt.internal.ui.text.JavaPairMatcher;
+import org.eclipse.jface.dialogs.MessageDialog;
+import org.eclipse.jface.text.BadLocationException;
+import org.eclipse.jface.text.IDocument;
+import org.eclipse.jface.text.ITextViewerExtension2;
+import org.eclipse.jface.text.ITypedRegion;
+import org.eclipse.jface.text.source.ISourceViewer;
+import org.eclipse.jface.text.source.MatchingCharacterPainter;
+import org.eclipse.jface.text.source.SourceViewer;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.custom.StyleRange;
+import org.eclipse.swt.events.KeyEvent;
+import org.eclipse.swt.events.KeyListener;
+import org.eclipse.swt.events.MouseEvent;
+import org.eclipse.swt.events.MouseListener;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.ui.IFileEditorInput;
+import org.eclipse.ui.editors.text.TextEditor;
+import org.eclipse.ui.texteditor.ContentAssistAction;
+import org.eclipse.ui.texteditor.ITextEditorActionDefinitionIds;
+import org.eclipse.ui.texteditor.MarkerUtilities;
+import org.eclipse.ui.views.contentoutline.IContentOutlinePage;
+import org.jboss.ide.eclipse.freemarker.Constants;
+import org.jboss.ide.eclipse.freemarker.Plugin;
+import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
+import org.jboss.ide.eclipse.freemarker.editor.ColorManager;
+import org.jboss.ide.eclipse.freemarker.editor.DocumentProvider;
+import org.jboss.ide.eclipse.freemarker.model.Item;
+import org.jboss.ide.eclipse.freemarker.model.ItemSet;
+import org.jboss.ide.eclipse.freemarker.outline.OutlinePage;
+
+import freemarker.core.ParseException;
+import freemarker.template.Configuration;
+import freemarker.template.Template;
+
+/**
+ * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
+ */
+public class SourceEditor extends TextEditor implements KeyListener, MouseListener {
+
+	private OutlinePage fOutlinePage;
+	private org.jboss.ide.eclipse.freemarker.editor.Configuration configuration;
+	private ColorManager colorManager = new ColorManager();
+
+	private ItemSet itemSet;
+	private Item selectedItem;
+	private Item[] relatedItems;
+	private static final char[] VALIDATION_TOKENS = new char[]{'\"', '[', ']', ',', '.', '\n', '4'};
+	private boolean readOnly = false;
+
+	private boolean mouseDown = false;
+	private boolean ctrlDown = false;
+	private boolean shiftDown = false;
+
+	public SourceEditor() {
+		super();
+		configuration = new org.jboss.ide.eclipse.freemarker.editor.Configuration(getPreferenceStore(), colorManager, this);
+		setSourceViewerConfiguration(configuration);
+		setDocumentProvider(new DocumentProvider());
+	}
+	
+	
+	
+	public void dispose() {
+		ConfigurationManager.getInstance(getProject()).reload();
+		super.dispose();
+		if(matchingCharacterPainter!=null) {
+			matchingCharacterPainter.dispose();
+		}
+	}
+
+	public Object getAdapter(Class aClass) {
+	    Object adapter;
+		if (aClass.equals(IContentOutlinePage.class)) {
+			if (fOutlinePage == null) {
+			    fOutlinePage = new OutlinePage(this);
+				if (getEditorInput() != null) {
+					fOutlinePage.setInput(getEditorInput());
+				}
+			}
+			adapter = fOutlinePage;
+		} else {
+		    adapter = super.getAdapter(aClass);
+		}
+		return adapter;
+	}
+
+	protected static final char[] BRACKETS= {'{', '}', '(', ')', '[', ']', '<', '>' };
+	private MatchingCharacterPainter matchingCharacterPainter;
+	public void createPartControl(Composite parent) {
+		super.createPartControl(parent);
+		 getSourceViewer().getTextWidget().addKeyListener(this);
+		 getSourceViewer().getTextWidget().addMouseListener(this);
+		 //matchingCharacterPainter = new MatchingCharacterPainter(
+			//	 getSourceViewer(),
+				// new JavaPairMatcher(BRACKETS));
+		//((SourceViewer) getSourceViewer()).addPainter(matchingCharacterPainter);
+	}
+
+	protected void createActions() {
+		super.createActions();
+		// Add content assist propsal action
+		ContentAssistAction action = new ContentAssistAction(
+				Plugin.getDefault().getResourceBundle(),
+				"FreemarkerEditor.ContentAssist", this);
+		action.setActionDefinitionId(ITextEditorActionDefinitionIds.CONTENT_ASSIST_PROPOSALS);
+		setAction("FreemarkerEditor.ContentAssist", action);
+		action.setEnabled(true);
+	}
+
+	protected void handleCursorPositionChanged() {
+		super.handleCursorPositionChanged();
+		if (!mouseDown) {
+			int offset = getCaretOffset();
+			Item item = getItemSet().getSelectedItem(offset);
+			if (null == item && offset > 0) item = getItemSet().getSelectedItem(offset-1);
+			if (Plugin.getInstance().getPreferenceStore().getBoolean(
+					Constants.HIGHLIGHT_RELATED_ITEMS)) {
+				if (null != item && null != item.getRelatedItems() && item.getRelatedItems().length > 0) {
+					highlightRelatedRegions(item.getRelatedItems(), item);
+				}
+				else {
+					highlightRelatedRegions(null, item);
+				}
+			}
+			if (null == item) {
+				item = getItemSet().getContextItem(getCaretOffset());
+			}
+			if (null != fOutlinePage)
+				fOutlinePage.update(item);
+		}
+	}
+	public void mouseDoubleClick(MouseEvent e) {
+	}
+	public void mouseDown(MouseEvent e) {
+		mouseDown = true;
+	}
+	public void mouseUp(MouseEvent e) {
+		mouseDown = false;
+		handleCursorPositionChanged();
+	}
+
+	public void select (Item item) {
+		selectAndReveal(item.getRegion().getOffset(), item.getRegion().getLength());
+	}
+
+	public IDocument getDocument() {
+		ISourceViewer viewer = getSourceViewer();
+		if (viewer != null) {
+			return viewer.getDocument();
+		}
+		return null;
+	}
+
+	public void addProblemMarker(String aMessage, int aLine) {
+		IFile file = ((IFileEditorInput)getEditorInput()).getFile(); 
+		try {
+			Map attributes = new HashMap(5);
+			attributes.put(IMarker.SEVERITY, new Integer(IMarker.SEVERITY_ERROR));
+			attributes.put(IMarker.LINE_NUMBER, new Integer(aLine));
+			attributes.put(IMarker.MESSAGE, aMessage);
+			attributes.put(IMarker.TEXT, aMessage);
+			MarkerUtilities.createMarker(file, attributes, IMarker.PROBLEM);
+		} catch (Exception e) {
+			
+		}
+	}
+
+	private synchronized void highlightRelatedRegions (Item[] items, Item selectedItem) {
+		if (null == items || items.length == 0) {
+			if (null != relatedItems && relatedItems.length > 0) {
+				for (int i=0; i<relatedItems.length; i++) {
+					if (getDocument().getLength() >= relatedItems[i].getRegion().getOffset() + relatedItems[i].getRegion().getLength()) {
+						if (null == this.selectedItem || !relatedItems[i].equals(this.selectedItem))
+							resetRange(relatedItems[i].getRegion());
+					}
+				}
+			}
+			relatedItems = null;
+		}
+		if (null != relatedItems) {
+			for (int i=0; i<relatedItems.length; i++) {
+				if (getDocument().getLength() >= relatedItems[i].getRegion().getOffset() + relatedItems[i].getRegion().getLength()) {
+					if (null == this.selectedItem || !relatedItems[i].equals(this.selectedItem))
+						resetRange(relatedItems[i].getRegion());
+				}
+			}
+		}
+		if (null != items && items.length > 0) {
+			for (int i=0; i<items.length; i++) {
+				if (getDocument().getLength() >= items[i].getRegion().getOffset() + items[i].getRegion().getLength()
+						&& !items[i].equals(selectedItem)) {
+					ITypedRegion region = items[i].getRegion();
+					getSourceViewer().getTextWidget().setStyleRange(
+							new StyleRange(region.getOffset(),
+									region.getLength(), null, 
+									colorManager.getColor(
+											Constants.COLOR_RELATED_ITEM)));
+				}
+			}
+		}
+		relatedItems = items;
+		this.selectedItem = selectedItem;
+	}
+
+	private void resetRange (ITypedRegion region) {
+		if (getSourceViewer() instanceof ITextViewerExtension2)
+			((ITextViewerExtension2) getSourceViewer()).invalidateTextPresentation(region.getOffset(), region.getLength());
+		else
+			getSourceViewer().invalidateTextPresentation();
+	}
+
+	public Item getSelectedItem (boolean allowFudge) {
+		int caretOffset = getCaretOffset();
+		Item item = getItemSet().getSelectedItem(getCaretOffset());
+		if (null == item && caretOffset > 0) item = getItemSet().getSelectedItem(caretOffset - 1);
+		return item;
+	}
+
+	public Item getSelectedItem () {
+		return getItemSet().getSelectedItem(getCaretOffset());
+	}
+
+	public int getCaretOffset () {
+		return getSourceViewer().getTextWidget().getCaretOffset();
+	}
+
+	public void clearCache () {
+		this.itemSet = null;
+	}
+
+	public ItemSet getItemSet () {
+		if (null == this.itemSet) {
+			IResource resource = null;
+			if (getEditorInput() instanceof IFileEditorInput) {
+				resource = ((IFileEditorInput) getEditorInput()).getFile();
+			}
+			else if (getEditorInput() instanceof JarEntryEditorInput) {
+				resource = null;
+			}
+			
+			this.itemSet = new ItemSet(
+					getSourceViewer(), resource);
+		}
+		return this.itemSet;
+			
+	}
+	public OutlinePage getOutlinePage() {
+		return fOutlinePage;
+	}
+
+	public void keyPressed(KeyEvent e) {
+		if (e.keyCode == SWT.CTRL) {
+			ctrlDown = true;
+		}
+		if (e.keyCode == SWT.SHIFT) {
+			shiftDown = true;
+		}
+		if (e.keyCode == ']') {
+			try {
+				char c = getDocument().getChar(getCaretOffset());
+				if (c == ']') {
+					// remove this
+					getDocument().replace(getCaretOffset(), 1, "");
+				}
+			}
+			catch (BadLocationException e1) {}
+		}
+		else if (e.keyCode == '}') {
+			try {
+				char c = getDocument().getChar(getCaretOffset());
+				if (c == '}') {
+					// remove this
+					getDocument().replace(getCaretOffset(), 1, "}");
+				}
+			}
+			catch (BadLocationException e1) {}
+		}
+	}
+
+	public void keyReleased(KeyEvent e) {
+		if (e.keyCode == SWT.CTRL) {
+			ctrlDown = false;
+		}
+		else if (e.keyCode == SWT.SHIFT) {
+			shiftDown = false;
+		}
+		try {
+			if (shiftDown && (e.keyCode == '3' || e.keyCode == '2')) {
+				int offset = getCaretOffset();
+				char c = getSourceViewer().getDocument().getChar(offset-2);
+				if (c == '[' || c == '<') {
+					// directive
+					char endChar = Character.MIN_VALUE;
+					if (c == '[') endChar = ']'; else endChar = '>';
+					if (getSourceViewer().getDocument().getLength() > offset) {
+						if (offset > 0) {
+							for (int i=offset+1; i<getSourceViewer().getDocument().getLength(); i++) {
+								char c2 = getSourceViewer().getDocument().getChar(i);
+								if (i == endChar) return;
+								else if (i == '\n') break;
+							}
+							getSourceViewer().getDocument().replace(offset, 0, new String(new char[]{endChar}));
+						}
+					}
+					else {
+						getSourceViewer().getDocument().replace(offset, 0, new String(new char[]{endChar}));
+					}
+				}
+			}
+			else if (shiftDown && e.keyCode == '[') {
+				int offset = getCaretOffset();
+				char c = getSourceViewer().getDocument().getChar(offset-2);
+				if (c == '$') {
+					// interpolation
+					if (getSourceViewer().getDocument().getLength() > offset) {
+						if (offset > 0) {
+							for (int i=offset+1; i<getSourceViewer().getDocument().getLength(); i++) {
+								char c2 = getSourceViewer().getDocument().getChar(i);
+								if (i == '}') return;
+								else if (i == '\n') break;
+							}
+							getSourceViewer().getDocument().replace(offset, 0, "}");
+						}
+					}
+					else {
+						getSourceViewer().getDocument().replace(offset, 0, "}");
+					}
+				}
+			}
+		}
+		catch (BadLocationException exc) {
+			// do nothing
+		}
+
+		boolean stale = false;
+		if (e.keyCode == SWT.DEL || e.keyCode == SWT.BS) {
+			stale = true;
+		}
+		else if (null != getSelectedItem(true)) {
+			stale = true;
+		}
+		else {
+			char c = (char) e.keyCode;
+			for (int j=0; j<VALIDATION_TOKENS.length; j++) {
+				if (c == VALIDATION_TOKENS[j]) {
+					stale = true;
+					break;
+				}
+			}
+			if (ctrlDown && (e.keyCode == 'v' || e.keyCode == 'x')) {
+				stale = true;
+			}
+		}
+		if (stale) {
+			int offset = getCaretOffset();
+			Item item = getItemSet().getSelectedItem(offset);
+			if (null == item && offset > 0) item = getItemSet().getSelectedItem(offset-1);
+			if (Plugin.getInstance().getPreferenceStore().getBoolean(
+					Constants.HIGHLIGHT_RELATED_ITEMS)) {
+				if (null != item && null != item.getRelatedItems() && item.getRelatedItems().length > 0) {
+					highlightRelatedRegions(item.getRelatedItems(), item);
+				}
+				else {
+					highlightRelatedRegions(null, item);
+				}
+			}
+			clearCache();
+			validateContents();
+			if (null != fOutlinePage)
+				fOutlinePage.update(getSelectedItem());
+		}
+	}
+
+	private void showMessage (String text) {
+		MessageDialog.openError(
+				getSourceViewer().getTextWidget().getShell(),
+				"message",
+				text);
+	}
+
+	public static Validator VALIDATOR;
+	public synchronized void validateContents () {
+		if (null == VALIDATOR) {
+			VALIDATOR = new Validator(this);
+			VALIDATOR.start();
+		}
+	}
+
+	public IProject getProject () {
+		return ((IFileEditorInput) getEditorInput()).getFile().getProject();
+	}
+
+	public IFile getFile () {
+		return (null != getEditorInput()) ? 
+				((IFileEditorInput) getEditorInput()).getFile() : null;
+	}
+
+	private Configuration fmConfiguration;
+	public class Validator extends Thread {
+		SourceEditor editor;
+		public Validator (SourceEditor editor) {
+			this.editor = editor;
+		}
+		public void run () {
+			try {
+				if (null != getFile()) {
+					if (null == fmConfiguration) {
+						fmConfiguration = new Configuration();
+						fmConfiguration.setTagSyntax(Configuration.AUTO_DETECT_TAG_SYNTAX); 
+					}
+					getFile().deleteMarkers(IMarker.PROBLEM, true, IResource.DEPTH_INFINITE);
+					String pageContents = getDocument().get();
+					Reader reader = new StringReader(pageContents);
+					new Template(getFile().getName(), reader, fmConfiguration);
+					reader.close();
+				}
+			}
+			catch (ParseException e) {
+				if (e.getMessage() != null) {
+					String errorStr = e.getMessage();
+					int errorLine = 0;
+					try {
+						errorLine = e.getLineNumber();
+						if (errorLine == 0) {
+							// sometimes they forget to put it in
+							int index = e.getMessage().indexOf("line: ");
+							if (index > 0) {
+								int index2 = e.getMessage().indexOf(" ", index+6);
+								int index3 = e.getMessage().indexOf(",", index+6);
+								if (index3 < index2 && index3 > 0) index2 = index3;
+								String s = e.getMessage().substring(index+6, index2);
+								try {
+									errorLine = Integer.parseInt(s);
+								}
+								catch (Exception e2) {}
+							}
+						}
+					} catch (NullPointerException npe) {
+						errorLine = 0;
+					}
+					editor.addProblemMarker(errorStr, errorLine);
+				}
+			}
+			catch (Exception e) {
+				Plugin.log(e);
+			}
+			finally {
+				editor.VALIDATOR = null;
+			}
+		}
+	}
+
+	protected void editorSaved() {
+		super.editorSaved();
+		validateContents();
+	}
+
+	public boolean isEditorInputReadOnly() {
+		return readOnly;
+	}
+	public void setReadOnly(boolean readOnly) {
+		this.readOnly = readOnly;
+	}
+	
+	public ISourceViewer getInternalSourceViewer() {
+		return super.getSourceViewer();
+	}
+}
